/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.web.beans.admin;

import com.arrebol.apc.controller.GenericController;
import com.arrebol.apc.controller.admin.StatsPayrollController;
import com.arrebol.apc.model.core.User;
import com.arrebol.apc.model.views.StatsPayrollView;
import com.arrebol.apc.web.beans.Datatable;
import com.arrebol.apc.web.beans.GenericBean;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.view.ViewScoped;
import javax.inject.Named;
import org.primefaces.event.ReorderEvent;
import org.primefaces.event.RowEditEvent;

/**
 *
 * @author David Rodriguez
 */
@Named("statsPayrollManager")
@ViewScoped
public class StatsPayrollBean extends GenericBean implements Serializable, Datatable {

    public void searchHistoricalAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setPayroll(fillDatatablePayroll());
                setTotalValue();
            }
        } catch (Exception e) {
        }
    }

    public BigDecimal searchTotalPayrollAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setTotalValue();
            }
        } catch (Exception e) {
        }
        return getTotalPayroll();
    }

    public StatsPayrollController getPayrollCtrl() {
        return payrollCtrl;
    }

    public void setPayrollCtrl(StatsPayrollController payrollCtrl) {
        this.payrollCtrl = payrollCtrl;
    }

    public GenericController getGenericCtrl() {
        return genericCtrl;
    }

    public void setGenericCtrl(GenericController genericCtrl) {
        this.genericCtrl = genericCtrl;
    }

    public List<StatsPayrollView> fillDatatablePayroll() {
        return getPayrollCtrl().fillPayrollDataTable(getStarDate(), getEndDate(), getUserSelectedId());
    }

    public BigDecimal fillTotalPayroll() {
        return getPayrollCtrl().fillTotalPayroll(getStarDate(), getEndDate());
    }

    public List<StatsPayrollView> getPayroll() {
        return payroll;
    }

    public void setPayroll(List<StatsPayrollView> payroll) {
        this.payroll = payroll;
    }

    public StatsPayrollView getSelectedPayroll() {
        return selectedPayroll;
    }

    public void setSelectedPayroll(StatsPayrollView selectedPayroll) {
        this.selectedPayroll = selectedPayroll;
    }

    public BigDecimal getTotalPayroll() {
        return totalPayroll;
    }

    public void setTotalPayroll(BigDecimal totalPayroll) {
        this.totalPayroll = totalPayroll;
    }
    
    public List<User> getUsers() {
        return genericCtrl.getAllUsersByOffice(getLoggedUser().getOffice().getId());
    }
    
    public String getUserSelectedId() {
        return userSelectedId;
    }

    public void setUserSelectedId(String userSelectedId) {
        this.userSelectedId = userSelectedId;
    }    

    private StatsPayrollController payrollCtrl;
    private GenericController genericCtrl;
    private List<StatsPayrollView> payroll;
    private StatsPayrollView selectedPayroll;
    private BigDecimal totalPayroll;
    private List<User> users;
    private String userSelectedId;    

    @PostConstruct
    public void init() {
        loadBundlePropertyFile();
        initStartAndEndDates(Calendar.DAY_OF_WEEK, 2);

        payrollCtrl = new StatsPayrollController();
        genericCtrl = new GenericController();
        payroll = fillDatatablePayroll();
        setTotalValue();
        users = getUsers();
    }

    @Override
    public void editRow(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowCancel(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowReorder(ReorderEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void addRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void deleteRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    private void setTotalValue() {
        if (payroll != null && !payroll.isEmpty()) {
            setTotalPayroll(payroll.stream().map(StatsPayrollView::getTotalPayroll).reduce(BigDecimal::add).get());
        } else {
            setTotalPayroll(BigDecimal.ZERO);
        }
    }
}
